# YourAppIdea

Project template for android and demo app for tutorials on [michenux.net](http://www.michenux.net)

The demo application is available on Google Play:

 [![Get it on Google Play](http://www.android.com/images/brand/get_it_on_play_logo_small.png)](https://play.google.com/store/apps/details?id=org.michenux.yourappidea)

## Requirements

* Android SDK 19 (with extras/Google Repository)
* Android Studio

## What you can find inside

**Implemented UI Patterns**

* Navigation Drawer (ActionBarActivity)
* List/Detail (fragment)
* Spinner in ActionBar
* Refresh button in Action Bar
* Contextual toasts with Crouton library
* Pull To Refresh with library ActionBar-PullToRefresh


**Improove UX**

* Animations on buttons
* Different layouts in landscape mode
* No splashscreen (because anti-pattern)


**Architecture**

* Dependency injection with Dagger


**Persistence**

* Sqlite Database : manage creation/upgrade of database using sql scripts
* ContentProvider examples
* AsyncTaskLoader and CursorLoader


**Network**

* Json Request with Volley library
* SyncAdapter
* Retrieve posts from wordpress website


**Geoloc**

* Localization with Google Play Services
* Geocoder example, Distance compute, sort by distance


**Promote your app**

* Link to the application on Google Play Store for adding rating/comments
* ChangeLog screen (can show what's new since previous version or display full changelog)


**Monetize your app**

* Integration of admob
* Donation screen (paypal)


**Others**

* User login via facebook/google+
* Preferences (using Fragment and compatible with 2.2+)
* Eula (End User Licence Agreement) : accept/refuse Eula on first time or just display.
* Quit Dialog (not enabled by default cause anti-pattern)

## Credits

Author: Laurent Michenaud (lmichenaud@gmail.com)

<a href="https://plus.google.com/+LaurentMichenaud/posts">
  <img alt="Follow me on Google+"
       src="http://www.michenux.net/images/g+64.png" />
</a>
<a href="https://twitter.com/Michenux">
  <img alt="Follow me on Twitter"
       src="http://www.michenux.net/images/twitter64.png" />
</a>
<a href="http://www.linkedin.com/pub/laurent-michenaud/5/148/b32">
  <img alt="Follow me on LinkedIn"
       src="http://www.michenux.net/images/linkedin.png" />
</a>

License
-------

    Copyright 2013-2014 Laurent Michenaud

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.


---
